# The function 'quad(f,a,b,tol)':
# f should be defined by f=name(func). Here, func is an integrand.
# an adaptive simpson quadrature formula for \int_a^b func(x) dx.
# Here, tol is a tolerance of a conjected error.
# The variable _loop indicates the number of recursive calls of
# the function simstp.
# (c) Shin'ichi OISHI 2001/8/24

_loop = 0;

function quad(f,a,b,tol) {
#  tol = 0.00000000001;
  eps = 0.000000000000001;
  x = [a, (a+b)/2, b];
  y = [eval(f|a),eval(f|(a+b)/2),eval(f|b)]; 
  fa = y[0,0]; fm = y[0,1]; fb = y[0,2];
  yy = zeros(1,5);
  yy[0,0] = eval(f|a+0.9501*(b-a));
  yy[0,1] = eval(f|a+0.2311*(b-a));
  yy[0,2] = eval(f|a+0.6068*(b-a));
  yy[0,3] = eval(f|a+0.4860*(b-a));
  yy[0,4] = eval(f|a+0.8913*(b-a));
  sum_y = 0;
  sum_yy = 0;
  for(i=0;i<3;i=i+1) {
     sum_y = sum_y + y[0,i];
     sum_yy = sum_yy + yy[0,i]
  };
  is = (b - a)/8*(sum_y+sum_yy);
  is = is*tol/eps;
  Q = simstp(f,a,b,fa,fm,fb,is)
}

function simstp(f,a,b,fa,fm,fb,is) {
  m = (a + b)/2; h = (b - a)/4;
  x = [a + h, b - h];
  y = zeros(1,2);
  y[0,0] = eval(f|a+h);
  y[0,1] = eval(f|b-h);
  fml = y[0,0]; 
  fmr = y[0,1];
  i1 = h/1.5 * (fa + 4*fm + fb);
  i2 = h/3 * (fa + 4*(fml + fmr) + 2*fm + fb);
  i1 = (16*i2 - i1)/15;
  if (is + (i1-i2) == is) {
    Q = i1
  }
  else {
    _loop = _loop + 1;
    Q = simstp(f,a,m,fa,fml,fm,is) + simstp(f,m,b,fm,fmr,fb,is)
  }
}
