#include "slab.h"
#include<time.h>
#include "blaswrap.h"
#include "f2c.h"
void slb_matrix_tridiagonalize(double *A, double *w, long int n);
double norm_interval_matrix2(Complex *apd, Complex *apu, double *ewb, long int n);
double norm_interval_matrix(Complex *apd, Complex *apu, long int n);
static void luguaB(double *a, double *b, double *aa, double *g, double *x, long int N, long int m);
static void luguaB1(double *a, double *b, double *aa, double *g, double *x, long int N, long int m);
static void luguaB2(double *a, double *b, double *b1, double *aa, double *g, double *x, long int N, long int m);
int dlacpy_(char *uplo, integer *m, integer *n, double *
	a, integer *lda, double *b, integer *ldb);
int dtrmv_(char *uplo, char *trans, char *diag, integer *n, 
	double *a, integer *lda, double *x, integer *incx);
int zgetrf_(long int *l, long int *k, Complex *A, long int *ll, long int *ipiv, long int *info);
int zgesvd_(long int *jobu, long int *jobv, long int *l, long int *k, Complex *A, long int *lda, double *s_diag, Complex *u, long int *ldu, Complex *v, long int *ldv, Complex *work, long int *lwork, double *rwork, long int *info);
int dgesvd_(long int *jobu, long int *jobvt, integer *m, integer *n, 
	doublereal *a, integer *lda, doublereal *s, doublereal *u, integer *
	ldu, doublereal *vt, integer *ldvt, doublereal *work, integer *lwork, 
	integer *info);
int dgetrf_(integer *m, integer *n, doublereal *a, integer *
	lda, integer *ipiv, integer *info);
int dgees_(long int *jobvs, long int *sort, L_fp select, integer *n, 
	doublereal *a, integer *lda, integer *sdim, doublereal *wr, 
	doublereal *wi, doublereal *vs, integer *ldvs, doublereal *work, 
	integer *lwork, int *bwork, integer *info);
int zgees_(long int *jobvs, long int *sort, L_fp select, integer *n, 
	Complex *a, integer *lda, integer *sdim, Complex *w, 
	Complex *vs, integer *ldvs, Complex *work, integer *lwork,
	 double *rwork, int *bwork, integer *info);
int zgeqrf_(integer *m, integer *n, Complex *a, 
	integer *lda, Complex *tau, Complex *work, integer *lwork,
	 integer *info);
int zungqr_(integer *m, integer *n, integer *k, 
	Complex *a, integer *lda, Complex *tau, Complex *
	work, integer *lwork, integer *info);
int dgeqrf_(integer *m, integer *n, double *a, integer *
	lda, double *tau, double *work, integer *lwork, integer *info);
int dorgqr_(integer *m, integer *n, integer *k, double *
	a, integer *lda, double *tau, double *work, integer *lwork, 
	integer *info);
int dpotrf_(long int *uplo, integer *n, double *a, integer *
	lda, integer *info);
int zpotrf_(long int *uplo, integer *n, Complex *a, 
	integer *lda, integer *info);
double dlange_(char *norm, integer *m, integer *n, double *a, integer 
	*lda, double *work);
int dgemm_(char *transa, char *transb, integer *m, integer *
	n, integer *k, double *alpha, double *a, integer *lda, 
	double *b, integer *ldb, double *beta, double *c, integer 
	*ldc);
int zgemm_(char *transa, char *transb, integer *m, integer *
	n, integer *k, Complex *alpha, Complex *a, integer *lda, 
	Complex *b, integer *ldb, Complex *beta, Complex *c,
	 integer *ldc);
int zgetri_(integer *n, Complex *a, integer *lda, 
	integer *ipiv, Complex *work, integer *lwork, integer *info);
int ztrtri_(char *uplo, char *diag, integer *n, 
	Complex *a, integer *lda, integer *info);
int dtrtri_(char *uplo, char *diag, integer *n, double *
	a, integer *lda, integer *info);
int dgetri_(integer *n, double *a, integer *lda, integer 
	*ipiv, double *work, integer *lwork, integer *info);
int dsyev_(char *jobz, char *uplo, integer *n, double *a,
	 integer *lda, double *w, double *work, integer *lwork, 
	integer *info);
int zheev_(char *jobz, char *uplo, integer *n, Complex 
	*a, integer *lda, double *w, Complex *work, integer *lwork, 
	double *rwork, integer *info);
int dgeev_(char *jobvl, char *jobvr, integer *n, double *
	a, integer *lda, double *wr, double *wi, double *vl, 
	integer *ldvl, double *vr, integer *ldvr, double *work, 
	integer *lwork, integer *info);
int zgeev_(char *jobvl, char *jobvr, integer *n, 
	Complex *a, integer *lda, Complex *w, Complex *vl, 
	integer *ldvl, Complex *vr, integer *ldvr, Complex *work, 
	integer *lwork, double *rwork, integer *info);
int dtrtrs_(char *uplo, char *trans, char *diag, integer *n, 
	integer *nrhs, double *a, integer *lda, double *b, integer *
	ldb, integer *info);
int dgesv_(integer *n, integer *nrhs, double *a, integer 
	*lda, integer *ipiv, double *b, integer *ldb, integer *info);
int ztrtrs_(char *uplo, char *trans, char *diag, integer *n, 
	integer *nrhs, Complex *a, integer *lda, Complex *b, 
	integer *ldb, integer *info);
int zgesv_(integer *n, integer *nrhs, Complex *a, 
	integer *lda, integer *ipiv, Complex *b, integer *ldb, integer *
	info);
int dgemv_(char *trans, integer *m, integer *n, double *
	alpha, double *a, integer *lda, double *x, integer *incx, 
	double *beta, double *y, integer *incy);
integer idamax_(integer *n, double *dx, integer *incx);
int dcopy_(integer *n, double *dx, integer *incx, 
	double *dy, integer *incy);

void
slb_complex_lu(Complex *A, double *B, long int k, long int l)
{
    long int *ipiv, *q, t;
    int i, j;
    long int info;

    ipiv = (long int *)GC_malloc_atomic(k*sizeof(long int));
    q = (long int *)GC_malloc_atomic(k*sizeof(long int));
    for (i=0; i<k; ++i) {
        q[i] = i;
    }
    
    zgetrf_(&l, &k, A, &l, ipiv, &info);

    for(i=0; i<k; ++i) {
        j=ipiv[i]-1;
        t=q[i];
        q[i]=q[j];
        q[j]=t;
    }

    for(i=0; i<k; ++i) {
        B[i*k+q[i]] = 1.0;
    }
    
    GC_free(ipiv); 
    GC_free(q);
}

void
slb_complex_svd(Complex *A, Complex *u, double *s, Complex *v,
             long int k, long int l)
{
    int i;
    long int min, max, lda, ldu, ldv, lwork, info;
    long int jobu, jobv;
    Complex *work;
    double *s_diag, *rwork;

    min = k;
    max = k;
    if (l<k) 
    {
        min = l;
    }
    if (k<l)
    {
        max = l;
    }
    
    lda = l;
    lwork = (long int)(2 * min + max);

    jobu = (long int) 'A';
    jobv = (long int) 'A';
    ldu = l;
    ldv = k;
    s_diag = (double *)GC_malloc_atomic(min * sizeof(double)); 
    for(i=0; i<min; i++) {
        s_diag[i] = 0.;
    }
    work = (Complex *)GC_malloc(lwork * sizeof(Complex));
    rwork = (double *)GC_malloc_atomic(5*max * sizeof(double));
    

    zgesvd_(&jobu, &jobv, &l, &k, A, &lda, s_diag, u, &ldu, v, &ldv, 
            work, &lwork, rwork, &info);

    for(i=0; i<min; ++i) 
    {
        s[i+i*l]=s_diag[i];
    }
   
    if((int) info < 0)
    {
        fprintf(stderr, "Error: %ith aggument to zgesvd_ is not good \n",
        (int) -info);
    }
    if((int) info > 0)
    {
        fprintf(stderr, "Iteration for Singular value decomposition does not converge \n");
    }

    GC_free(work); 
    GC_free(rwork); 
    GC_free(s_diag);
}

void
slb_svd(double *A, double *u, double *s, double *v,
             long int k, long int l)
{
    int i;
    long int min, max, lda, ldu, ldv, lwork1, lwork, info;
    long int jobu, jobv;
    double *work, *s_diag;

    min = k;
    max = k;
    if (l<k) 
    {
        min = l;
    }
    if (k<l)
    {
        max = l;
    }
    
    lda = l;
    lwork = (long int)(3 * min + max);
    lwork1 = (long int)(5 * min -4); 
    if (lwork1 > lwork)
    {
        lwork = lwork1;
    }

    jobu = (long int) 'A';
    jobv = (long int) 'A';
    ldu = l;
    ldv = k;
    s_diag = (double *)GC_malloc_atomic(min * sizeof(double)); 
    for(i=0; i<min; i++) {
       s_diag[i] = 0.;
    }
    work = (double *)GC_malloc_atomic(lwork * sizeof(double));

    dgesvd_(&jobu, &jobv, &l, &k, A, &lda, s_diag, u, &ldu, v, &ldv, 
            work, &lwork, &info);

    for(i=0; i<min; ++i) 
    {
        s[i+i*l]=s_diag[i];
    }
   
    if((int) info < 0)
    {
        fprintf(stderr, "Error: %ith aggument to dgesvd_ is not good \n",
        (int) -info);
    }
    if((int) info > 0)
    {
        fprintf(stderr, "Iteration for Singular value decomposition does not converge \n");
    }

    GC_free(work); 
    GC_free(s_diag);
}

void
slb_lu(double *A, double *B, long int k, long int l)
{
    long int *ipiv, *q, t;
    int i, j;
    long int info;

    ipiv = (long int *)GC_malloc_atomic(k*sizeof(long int));
    q = (long int *)GC_malloc_atomic(k*sizeof(long int));
    for (i=0; i<k; ++i) {
        q[i] = i;
    }
    
    dgetrf_(&l, &k, A, &l, ipiv, &info);

    for(i=0; i<k; ++i) {
        j=ipiv[i]-1;
        t=q[i];
        q[i]=q[j];
        q[j]=t;
    }

    for(i=0; i<k; ++i) {
        B[i*k+q[i]] = 1.0;
    }
    
    GC_free(ipiv); 
    GC_free(q);
}

static
void (*rselect) ();          /*  dummy  */

void
slb_schur(double *A, double *vs, long int n)
{
    long int info, lda, lwork, sdim, jobvs, sort;
    int *bwork;
    double *wr, *wi, *work;

    lda = n;
    sdim = 0;
    lwork = 3*n;
    bwork = (int *)GC_malloc_atomic(2*sizeof(int));
    jobvs = (long int) 'V';
    sort  = (long int) 'N';

    wr = (double *)GC_malloc_atomic(n*sizeof(double));
    wi = (double *)GC_malloc_atomic(n*sizeof(double));
    work = (double *)GC_malloc_atomic(lwork * sizeof(double));

    dgees_(&jobvs, &sort, rselect, &n, A, &lda, &sdim, wr, wi, vs,
           &n, work, &lwork, bwork, &info);

    GC_free(wr);
    GC_free(wi);
    GC_free(work);
    GC_free(bwork);
}


void
slb_complex_schur(Complex *A, Complex *vs, long int n)

{
    long int info, lda, lwork, sdim, jobvs, sort;
    int *bwork;
    Complex *w, *work;
    double  *rwork;

    lda = n;
    sdim = 0;
    lwork = 3*n;
    bwork = (int *)GC_malloc_atomic(2*sizeof(int));
    jobvs = (long int) 'V';
    sort  = (long int) 'N';

    w = (Complex *)GC_malloc(n*sizeof(Complex));
    rwork = (double *)GC_malloc_atomic(n*sizeof(double));
    work  = (Complex *)GC_malloc_atomic(lwork * sizeof(Complex));

    zgees_(&jobvs, &sort, rselect, &n, A, &lda, &sdim, w, vs,
           &n, work, &lwork, rwork, bwork, &info);

    GC_free(w);
    GC_free(rwork);
    GC_free(work);
    GC_free(bwork);
}



void
slb_complex_qr(Complex *A, Complex *B, long int k, long int l)
{
    Complex *tau;
    Complex *work;
    long int min_mn;
    int i;
    long int info, lwork;

    min_mn = k;
    if (l<k) {
       min_mn = l;
    }
    tau = (Complex *)GC_malloc(min_mn*sizeof(Complex));
    lwork = 4*l;
    work = (Complex *)GC_malloc(lwork*sizeof(Complex));
    zgeqrf_(&l, &k, A, &l, tau, work, &lwork, &info);
    for(i=0; i<l*l; ++i) {
        B[i] = A[i];
    }
    
    zungqr_(&l, &l, &min_mn, B, &l, tau, work, &lwork, &info);
  
    GC_free(tau);
    GC_free(work); 
}

void
slb_qr(double *A, double *B, long int k, long int l)
{
    double *tau;
    double *work;
    long int min_mn;
    int i;
    long int info, lwork;

    min_mn = k;
    if (l<k) {
       min_mn = l;
    }
    tau = (double *)GC_malloc_atomic(min_mn*sizeof(double));
    lwork = 4*l;
    work = (double *)GC_malloc_atomic(lwork*sizeof(double));
    dgeqrf_(&l, &k, A, &l, tau, work, &lwork, &info);
    for(i=0; i<l*l; ++i) {
        B[i] = A[i];
    }
    
    dorgqr_(&l, &l, &min_mn, B, &l, tau, work, &lwork, &info);
  
    GC_free(tau);
    GC_free(work); 
}

void 
slb_chol(double *A, long int l)
{
    long int info, uplo;
    int i, j;

    uplo = (long int) 'U';

    dpotrf_(&uplo, &l, A, &l, &info);

    if ((int) info < 0)
    {
        fprintf(stderr, "bad argument for doptrf_\n");
    }
    if ((int) info > 0)
    {
        fprintf(stderr, "input is not positive definite\n");
    }

    for (i=0; i<l; i++)
    {
        for (j=0; j<i; ++j)
        {
            A[i+j*l] = 0.0;
        }
    }
}

void 
slb_complex_chol(Complex *A, long int l)
{
    long int info, uplo;
    int i, j;

    uplo = (long int) 'U';

    zpotrf_(&uplo, &l, A, &l, &info);

    if ((int) info < 0)
    {
        fprintf(stderr, "bad argument for doptrf_\n");
    }
    if ((int) info > 0)
    {
        fprintf(stderr, "input is not positive definite\n");
    }

    for (i=0; i<l; i++)
    {
        for (j=0; j<i; ++j)
        {
            A[i+j*l].r = 0.0;
            A[i+j*l].i = 0.0;
        }
    }
}



double
slb_matrix_norm(long int no_row, long int no_column, double *a)
/* At present maximum norm is implemented */
{
    char norm='I';
    double *work;
    double result;
    double dummy;
    int i;

    work = (double*)calloc(no_row,sizeof(double));
    
    dummy = dlange_(&norm, &no_row, &no_column, a, &no_row, work);

/*
    for(i=0;i<no_row;i++) {
        for(j=0;j<no_column;++j) {
           work[i] += fabs(a[i+j*no_row]);
        }
    }
*/

    result = work[0];
    for(i=0;i<no_row;++i) {
        if(result<work[i]) {
            result = work[i];
        }
    }

    free(work);
    return result;
}

void
slb_matrix_multyply(double *a,double *b,double *c,long int m,long int n,long int k)
{
    char tra='N', trb='N';
    double alpha = 1.0;
    double beta = 0.0;

    dgemm_(&tra, &trb, &m, &n, &k, &alpha, a, &m, b, &k, &beta, c, &m);

}

void
slb_complex_matrix_multyply(Complex *a, Complex *b, Complex *c, long int m, long int n, long int k)
{
    char tra='N', trb='N';
    Complex alpha, beta;

    alpha.r = 1.0;
    alpha.i = 0.0;
    beta.r = 0.0;
    beta.i = 0.0;

    zgemm_(&tra, &trb, &m, &n, &k, &alpha, a, &m, b, &k, &beta, c, &m);

}

void
slb_matrix_interval_multyply(double *a, double *b, double *c, double *d, double *e, long int n, long int m)
{
    char tra='N', trb='N';
    double alpha1 = 1.0;
    double beta1 = 0.0;
    int i;
    double *ma, *rc, *rr;
    long int k;

    k=n;
 
    rc  = (double*)GC_malloc_atomic(n*m*sizeof(double));
    rr  = (double*)GC_malloc_atomic(n*m*sizeof(double));
    up();
    for(i=0; i<n*m; ++i) {
        rc[i] = (b[i]+c[i])/2;
        rr[i] = rc[i]-b[i];
    }
    dgemm_(&tra, &trb, &m, &n, &k, &alpha1, a, &m, rc, &k, &beta1, e, &m);
    dgemm_(&tra, &trb, &m, &n, &k, &alpha1, a, &m, rr, &k, &beta1, d, &m);
    for(i=0; i<n*m; ++i) {
       e[i] += d[i];
    }

    down();
    dgemm_(&tra, &trb, &m, &n, &k, &alpha1, a, &m, rc, &k, &beta1, d, &m);
    ma  = (double*)GC_malloc_atomic(n*n*sizeof(double));
    for(i=0; i<n*n; ++i) {
       ma[i] = -a[i];
    }
    dgemm_(&tra, &trb, &m, &n, &k, &alpha1, ma, &m, rr, &k, &beta1, rc, &m);
    for(i=0; i<n*m; ++i) {
       d[i] += rc[i];
    }
    GC_free(rc);
    GC_free(rr);
    GC_free(ma);
}

void
slb_complex_matrix_interval_vmultyply(Complex *a, Complex *in_d, Complex *in_u, Complex *out_d, Complex *out_u, long int n, long int m)
{
    char tra='N', trb='N';
    double alpha1 = 1.0;
    double beta1 = 0.0;
    int i;
    double *ar, *c1, *c2, *r1, *r2, *r3, *r4;
    
    ar  = (double*)GC_malloc_atomic(n*n*sizeof(double));
    c1  = (double*)GC_malloc_atomic(n*n*sizeof(double));
    c2  = (double*)GC_malloc_atomic(n*n*sizeof(double));
    r1  = (double*)GC_malloc_atomic(n*n*sizeof(double));
    r2  = (double*)GC_malloc_atomic(n*n*sizeof(double));

    for(i=0; i<n*n; ++i) {
        ar[i] = a[i].r;
        c1[i] = in_d[i].r;
        c2[i] = in_u[i].r;
    }
    slb_matrix_interval_multyply(ar, c1, c2, r1, r2, n, n);

    near();
    for(i=0; i<n*n; ++i) {
        ar[i] = -a[i].i;
        c1[i] = in_d[i].i;
        c2[i] = in_u[i].i;
    }
    r3  = (double*)GC_malloc_atomic(n*n*sizeof(double));
    r4  = (double*)GC_malloc_atomic(n*n*sizeof(double));
    slb_matrix_interval_multyply(ar, c1, c2, r3, r4, n, n);

    down();
    for(i=0; i<n*n; ++i) {
       out_d[i].r = r1[i] + r3[i];
    }
    up();
    for(i=0; i<n*n; ++i) {
       out_u[i].r = r2[i] + r4[i];
    }

    for(i=0; i<n*n; ++i) {
        ar[i] = a[i].i;
        c1[i] = in_d[i].r;
        c2[i] = in_u[i].r;
    }
    slb_matrix_interval_multyply(ar, c1, c2, r1, r2, n, n);

    for(i=0; i<n*n; ++i) {
        ar[i] = a[i].r;
        c1[i] = in_d[i].i;
        c2[i] = in_u[i].i;
    }
    slb_matrix_interval_multyply(ar, c1, c2, r3, r4, n, n);

    down();
    for(i=0; i<n*n; ++i) {
       out_d[i].i = r1[i] + r3[i];
    }
    up();
    for(i=0; i<n*n; ++i) {
       out_u[i].i = r2[i] + r4[i];
    }

    GC_free(ar);
    GC_free(c1);
    GC_free(c2);
    GC_free(r1);
    GC_free(r2);
    GC_free(r3);
    GC_free(r4);
}

void
slb_complex_matrix_vmultyply(Complex *a, Complex *b, Complex *c, long int m, long int n, long int k)
{
    char tra='N', trb='N';
    double *ar, *ai, *mai, *br, *bi, *cr, *ci, *cr1, *ci1;
    double alpha1 = 1.0;
    double beta1 = 0.0;
    int i;
    
    ar  = (double*)GC_malloc_atomic(n*n*sizeof(double));
    ai  = (double*)GC_malloc_atomic(n*n*sizeof(double));
    mai = (double*)GC_malloc_atomic(n*n*sizeof(double));
    br  = (double*)GC_malloc_atomic(n*n*sizeof(double));
    bi  = (double*)GC_malloc_atomic(n*n*sizeof(double));
    cr  = (double*)GC_malloc_atomic(n*n*sizeof(double));
    ci  = (double*)GC_malloc_atomic(n*n*sizeof(double));
    cr1  = (double*)GC_malloc_atomic(n*n*sizeof(double));
    ci1  = (double*)GC_malloc_atomic(n*n*sizeof(double));

    for(i=0; i<n*n; ++i) {
        ar[i]  =  a[i].r;
        ai[i]  =  a[i].i;
        mai[i] = -a[i].i;
        br[i]  =  b[i].r;
        bi[i]  =  b[i].i;
    }

    dgemm_(&tra, &trb, &m, &n, &k, &alpha1, ar, &m, br, &k, &beta1, cr, &m);
    dgemm_(&tra, &trb, &m, &n, &k, &alpha1, mai, &m, bi, &k, &beta1, cr1, &m);
    dgemm_(&tra, &trb, &m, &n, &k, &alpha1, ar, &m, bi, &k, &beta1, ci, &m);
    dgemm_(&tra, &trb, &m, &n, &k, &alpha1, ai, &m, br, &k, &beta1, ci1, &m);

    for(i=0; i<n*n; ++i) {
        c[i].r=cr[i]+cr1[i];
        c[i].i=ci[i]+ci1[i];
    }

    GC_free(ar);
    GC_free(ai);
    GC_free(mai);
    GC_free(br);
    GC_free(bi);
    GC_free(cr);
    GC_free(cr1);
    GC_free(ci);
    GC_free(ci1);
}

void 
slb_complex_matrix_inverse(Complex *A, Complex *c, long int n)
{
  int i;
  long int info,*piv, lwork;
  Complex *work;

  for(i=0; i<n*n; ++i) {
     c[i]=A[i];
  }

  piv = (long int*)GC_malloc_atomic(n*sizeof(long int));
  for(i=0; i<n; i++) {
     piv[i]=0;
  }

  zgetrf_(&n, &n, c, &n, piv, &info);

  work = (Complex*)GC_malloc(n*sizeof(Complex));
  lwork = n;

  zgetri_(&n, c, &n, piv, work, &lwork, &info); 

  GC_free(work); 
  GC_free(piv); 
}

void 
slb_complex_triangular_matrix_inverse(Complex *A, Complex *c, char uplo, char diag, long int n)
{
  int i;
  long int info;

  for(i=0; i<n*n; ++i) {
     c[i]=A[i];
  }

  ztrtri_(&uplo, &diag, &n, c, &n, &info);

}

void 
slb_triangular_matrix_inverse(double *A, double *c, char uplo, char diag, long int n)
{
  int i;
  long int info;

  for(i=0; i<n*n; ++i) {
     c[i]=A[i];
  }

  dtrtri_(&uplo, &diag, &n, c, &n, &info);

}

void 
slb_matrix_inverse(double *A, double *c, long int n)
{
  int i;
  long int info,*piv, lwork;
  double *work;

  for(i=0; i<n*n; ++i) {
     c[i]=A[i];
  }

  piv = (long int*)GC_malloc_atomic(n*sizeof(long int));
  for(i=0; i<n; i++) {
      piv[i] = 0;
  }

  dgetrf_(&n, &n, c, &n, piv, &info);

  work = (double*)GC_malloc_atomic(n*sizeof(double));
  lwork = n;

  dgetri_(&n, c, &n, piv, work, &lwork, &info); 

  GC_free(work); 
  GC_free(piv); 
}

void 
slb_matrix_tridiagonalize(double *A, double *tau, long int n)
{
  int i;
  char jobs = 'V', uplo = 'U';
  long int lda, info, lwork;
  double *work, *e, *d;

  lda = n;
  lwork = 64*n;
  work = (double*)GC_malloc_atomic(lwork*sizeof(double));
  e = (double*)GC_malloc_atomic((n-1)*sizeof(double));
  d = (double*)GC_malloc_atomic(n*sizeof(double));

  dsytrd_(&uplo, &n, A, &lda, d, e, tau, work, &lwork, &info);

  GC_free(e);
  GC_free(d);
  GC_free(work); 
}

void 
slb_matrix_eigenvalue(double *A, double *w, long int n)
{
  int i;
  char jobs = 'V', uplo = 'U';
  long int lda, info, lwork;
  double *work;

  lda = n;
  lwork = 64*n;
  work = (double*)GC_malloc_atomic(lwork*sizeof(double));

  dsyev_(&jobs, &uplo, &n, A, &lda, w, work, &lwork, &info);

  GC_free(work); 
}

void 
slb_he_matrix_eigenvalue(Complex *A, double *w, long int n)
{
  char jobz = 'V', uplo = 'U';
  long int lda, info, lwork;
  Complex *work;
  double  *rwork;

  lda = n;
  lwork = 64*n;
  work = (Complex*)GC_malloc(lwork*sizeof(Complex));
  rwork = (double *)GC_malloc((3*n-2)*sizeof(double));
  zheev_(&jobz, &uplo, &n, A, &lda, w, work, &lwork, rwork, &info);

  GC_free(rwork); 
  GC_free(work); 
}

void 
slb_ger_matrix_eigenvalue(double *A, double *w_real, double *w_imag, double *vec, long int n)
{
  char jobvl, jobvr;
  long int lda, info, lwork;
  long int ldvl, ldvr;
  double *work, *c, *vl; 
  int i;

  jobvl = 'N';
  jobvr = 'V';
  ldvl = 1;
  ldvr = n;
  vl = (double *)GC_malloc_atomic(ldvr*sizeof(double));

  c=(double *)GC_malloc_atomic(n*n*sizeof(double));
  for(i=0; i<n*n; ++i) {
     c[i]=A[i];
  }

  lda = n;
  lwork = 4*n;
  work = (double*)GC_malloc_atomic(lwork*sizeof(double));
  for(i=0; i<lwork; i++) {
      work[i]=0.;
  }

  dgeev_(&jobvl, &jobvr, &n, c, &lda, w_real, w_imag, vl, &ldvl, vec, &ldvr, work, &lwork, &info);

  GC_free(work); 
  GC_free(vl);
  GC_free(c);
}

double
norm_interval_matrix(Complex *apd, Complex *apu, long int n)
{
  int i, j;
  double tt, norm;

  for(i=0; i<n*n; ++i) {
      apu[i].r = sqrt(apu[i].r * apu[i].r + apu[i].i * apu[i].i);
      tt = sqrt(apd[i].r*apd[i].r+apd[i].i*apd[i].i);
      if(tt>apu[i].r) {
          apu[i].r = tt;
      }
  }
  norm=0.;
  for(i=0;i<n;++i) {
      tt=0;
      for(j=0;j<n;++j) {
          if(tt < apu[i+j*n].r) {
              tt=apu[i+j*n].r;
          } 
      } 
      if(tt > norm) {
          norm = tt;
      }
  }
  return norm;
}

void 
slab_solve_complex_matrix_equation(Complex *A, Complex *B, Complex *x, long int n, long int m)
{
  char jobvl = 'N', jobvr = 'V';
  long int lda, info, lwork;
  long int ldvl, ldvr;
  Complex *c, *d, *q, *apu, *apd, *u;
  double norm, temp1, tt, s;
  int i, j;
  long int time1,time2,time3;

  time1 = clock();

/*** Calculation of approximate solution of AX=B ***/
  near();
  slab_app_solve_complex_matrix_equation(A, B, x, n, m);
  time2 = clock();

/*** c is an approximate inverse of A          ***/
  c=(Complex *)GC_malloc(n*n*sizeof(Complex));
  slb_complex_matrix_inverse(A, c, n);

/*** Calculation of ||inv(A)*A - I||          ***/
  apu=(Complex *)GC_malloc(n*n*sizeof(Complex));
  apd=(Complex *)GC_malloc(n*n*sizeof(Complex));
  down();
  slb_complex_matrix_vmultyply(c, A, apd, n, n, n);
  for(i=0; i<n; ++i) {
      apd[i+i*n].r -= 1.;
  }
  up();
  slb_complex_matrix_vmultyply(c, A, apu, n, n, n);
  for(i=0; i<n; ++i) {
      apu[i+i*n].r -= 1.;
  }
  for(i=0; i<n*n; ++i) {
      apu[i].r = sqrt(apu[i].r * apu[i].r + apu[i].i * apu[i].i);
      tt = sqrt(apd[i].r*apd[i].r+apd[i].i*apd[i].i);
      if(tt>apu[i].r) {
          apu[i].r = tt;
      }
  }
  s=0.;
  for(i=0;i<n;++i) {
      tt=0;
      for(j=0;j<n;++j) {
          tt += apu[i+j*n].r;
      } 
      if(tt > s) {
          s = tt;
      }
  }
  printf("norm of inv(A)*A-I is %10.5e\n", s);
  down();
  s=1-s;

/*** Calculation of an error bound of X (1)       ***/
/*** Inclusion of Ax-B                           ***/
  u=(Complex *)GC_malloc(n*m*sizeof(Complex));
  d=(Complex *)GC_malloc(n*m*sizeof(Complex));
  down();
  slb_complex_matrix_vmultyply(A, x, d, n, m, n);
  up();
  slb_complex_matrix_vmultyply(A, x, u, n, m, n);
  for(i=0; i<n*m; ++i) {
     u[i].r -= B[i].r;
     u[i].i -= B[i].i;
  }
  down();
  for(i=0; i<n*n; ++i) {
     d[i].r -= B[i].r;
     d[i].i -= B[i].i;
  }

/*** Calculation of an error bound of X (2)       ***/
/*** Inclusion of inv(A)*(Ax-B)                  ***/
  slb_complex_matrix_interval_vmultyply(c, d, u, apd, apu, n, m); 
  GC_free(c);
  up();
  tt = norm_interval_matrix(apd, apu, n);
  GC_free(apu);
  GC_free(apd);
  tt/=s;
  printf("error is bounded by %10.5e\n", tt);
  time3 = clock();
  printf("time = solution : %5.3f, verification : %5.3f [sec]\n", 
             (double)(time2-time1)/CLOCKS_PER_SEC,
             (double)(time3-time2)/CLOCKS_PER_SEC);

  GC_free(x);
  GC_free(d);
  GC_free(u);
  near();
}

void 
slb_ger_matrix_veigenvalue(double *A1, Complex *w, Complex *vr, long int n)
{
  char jobvl = 'N', jobvr = 'V';
  long int lda, info, lwork;
  long int ldvl, ldvr;
  Complex *A, *work, *c, *vl, *d, *x, *q, *apu, *apd, *u;
  double *rwork, norm, temp1, tt, s;
  int i, j;
  long int time1,time2,time3;

/*** Determine Approximate eigen systems        ***/
/*** w is a vector consisting of vegenvalues,   ***/
/*** vr is a matrix of right eigenvectors       ***/ 
  time1 = clock();
  A=(Complex *)GC_malloc(n*n*sizeof(Complex));
  c=(Complex *)GC_malloc(n*n*sizeof(Complex));
  for(i=0; i<n*n; ++i) {
     A[i].r=c[i].r=A1[i];
     A[i].i=c[i].i=0.;
  }
  ldvl = 1;
  vl = (Complex *)GC_malloc(ldvl*sizeof(Complex));
  ldvr = n;
  lda = n;
  lwork = 64*n;
  work = (Complex *)GC_malloc(lwork*sizeof(Complex));
  rwork = (double *)GC_malloc_atomic(2*n*sizeof(double));
  zgeev_(&jobvl, &jobvr, &n, c, &lda, w, vl, &ldvl, vr, &ldvr, work, &lwork, rwork, &info);

  GC_free(work); 
  GC_free(rwork); 
  GC_free(vl);

  time2 = clock();

/*** q is an approximate inverse of vr          ***/
  slb_complex_matrix_inverse(vr, c, n);

/*** Calculation of ||inv(vr)*vr - I||          ***/
  apu=(Complex *)GC_malloc(n*n*sizeof(Complex));
  apd=(Complex *)GC_malloc(n*n*sizeof(Complex));
  down();
  slb_complex_matrix_vmultyply(c, vr, apd, n, n, n);
  for(i=0; i<n; ++i) {
      apd[i+i*n].r -= 1.;
  }
  up();
  slb_complex_matrix_vmultyply(c, vr, apu, n, n, n);
  for(i=0; i<n; ++i) {
      apu[i+i*n].r -= 1.;
  }
  for(i=0; i<n*n; ++i) {
      apu[i].r = sqrt(apu[i].r * apu[i].r + apu[i].i * apu[i].i);
      tt = sqrt(apd[i].r*apd[i].r+apd[i].i*apd[i].i);
      if(tt>apu[i].r) {
          apu[i].r = tt;
      }
  }
  s=0.;
  for(i=0;i<n;++i) {
      tt=0;
      for(j=0;j<n;++j) {
          tt += apu[i+j*n].r;
      } 
      if(tt > s) {
          s = tt;
      }
  }
  if(s<1) {
      printf("validation is succeeded!\n");
  }
  printf("norm of inv(P)*P-I is %10.5e\n", s);
  down();
  s=1-s;
  if(s<0) {
      printf("validation is failed\n");
  }

/*** Calculation of approximate solution of PX=AP ***/
  near();
  slb_complex_matrix_vmultyply(A, vr, apd, n, n, n);
  x=(Complex *)GC_malloc(n*n*sizeof(Complex));
  slab_app_solve_complex_matrix_equation(vr, apd, x, n, n);

/*** Calculation of an error bound of X (1)       ***/
/*** Inclusion of PX-AP                           ***/
  u=(Complex *)GC_malloc(n*n*sizeof(Complex));
  d=(Complex *)GC_malloc(n*n*sizeof(Complex));
  down();
  slb_complex_matrix_vmultyply(vr, x, d, n, n, n);
  up();
  slb_complex_matrix_vmultyply(vr, x, u, n, n, n);

  for(i=0; i<n*n; i++) {
     vr[i].r=-vr[i].r;
     vr[i].i=-vr[i].i;
  }
  slb_complex_matrix_vmultyply(A, vr, apu, n, n, n);
  for(i=0; i<n*n; ++i) {
     u[i].r += apu[i].r;
     u[i].i += apu[i].i;
  }
  down();
  slb_complex_matrix_vmultyply(A, vr, apd, n, n, n);
  for(i=0; i<n*n; ++i) {
     d[i].r += apd[i].r;
     d[i].i += apd[i].i;
  }

/*** Calculation of an error bound of X (2)       ***/
/*** Inclusion of inv(P)*(PX-AP)                  ***/
  slb_complex_matrix_interval_vmultyply(c, d, u, apd, apu, n, n); 
  GC_free(c);
  up();
  tt = norm_interval_matrix(apd, apu, n);
  GC_free(apu);
  GC_free(apd);
  tt/=s;
  printf("norm of ||tilde{X}-P^{-1}AP|| is %10.5e\n", tt);
  for(i=0; i<n*n; ++i) {
      u[i].r = x[i].r; 
      u[i].i = x[i].i; 
  }
  for(i=0; i<n; ++i) {
      u[i+i*n].r -=w[i].r;
      u[i+i*n].i -=w[i].i;
  }
  down();
  for(i=0; i<n*n; ++i) {
      d[i].r = x[i].r; 
      d[i].i = x[i].i; 
  }
  for(i=0; i<n; ++i) {
      d[i+i*n].r -=w[i].r;
      d[i+i*n].i -=w[i].i;
  }
  up();
  norm = norm_interval_matrix(d, u, n);
  tt += norm;
  printf("error is bounded by %10.5e\n", tt);
  time3 = clock();
  printf("time = solution : %5.3f, verification : %5.3f [sec]\n", 
             (double)(time2-time1)/CLOCKS_PER_SEC,
             (double)(time3-time2)/CLOCKS_PER_SEC);

  GC_free(x);
  GC_free(d);
  GC_free(u);
  near();
}

void 
slb_gec_matrix_veigenvalue(Complex *A, Complex *w, Complex *vr, long int n)
{
  char jobvl = 'N', jobvr = 'V';
  long int lda, info, lwork;
  long int ldvl, ldvr;
  Complex *work, *c, *vl, *d, *x, *q, *apu, *apd, *u;
  double *rwork, norm, temp1, tt, s;
  int i, j;
  long int time1,time2,time3;

/*** Determine Approximate eigen systems        ***/
/*** w is a vector consisting of vegenvalues,   ***/
/*** vr is a matrix of right eigenvectors       ***/ 
  time1 = clock();
  ldvl = 1;
  vl = (Complex *)GC_malloc(ldvl*sizeof(Complex));
  ldvr = n;
  c=(Complex *)GC_malloc(n*n*sizeof(Complex));
  for(i=0; i<n*n; ++i) {
     c[i].r=A[i].r;
     c[i].i=A[i].i;
  }
  lda = n;
  lwork = 64*n;
  work = (Complex *)GC_malloc(lwork*sizeof(Complex));
  rwork = (double *)GC_malloc_atomic(2*n*sizeof(double));
  zgeev_(&jobvl, &jobvr, &n, c, &lda, w, vl, &ldvl, vr, &ldvr, work, &lwork, rwork, &info);

  GC_free(work); 
  GC_free(rwork); 
  GC_free(vl);

  time2 = clock();

/*** q is an approximate inverse of vr          ***/
  slb_complex_matrix_inverse(vr, c, n);

/*** Calculation of ||inv(vr)*vr - I||          ***/
  apu=(Complex *)GC_malloc(n*n*sizeof(Complex));
  apd=(Complex *)GC_malloc(n*n*sizeof(Complex));
  down();
  slb_complex_matrix_vmultyply(c, vr, apd, n, n, n);
  for(i=0; i<n; ++i) {
      apd[i+i*n].r -= 1.;
  }
  up();
  slb_complex_matrix_vmultyply(c, vr, apu, n, n, n);
  for(i=0; i<n; ++i) {
      apu[i+i*n].r -= 1.;
  }
  for(i=0; i<n*n; ++i) {
      apu[i].r = sqrt(apu[i].r * apu[i].r + apu[i].i * apu[i].i);
      tt = sqrt(apd[i].r*apd[i].r+apd[i].i*apd[i].i);
      if(tt>apu[i].r) {
          apu[i].r = tt;
      }
  }
  s=0.;
  for(i=0;i<n;++i) {
      tt=0;
      for(j=0;j<n;++j) {
          tt += apu[i+j*n].r;
      } 
      if(tt > s) {
          s = tt;
      }
  }
  if(s<1) {
      printf("validation is succeeded!\n");
  }
  printf("norm of inv(P)*P-I is %10.5e\n", s);
  down();
  s=1-s;

/*** Calculation of approximate solution of PX=AP ***/
  near();
  slb_complex_matrix_vmultyply(A, vr, apd, n, n, n);
  x=(Complex *)GC_malloc(n*n*sizeof(Complex));
  slab_app_solve_complex_matrix_equation(vr, apd, x, n, n);

/*** Calculation of an error bound of X (1)       ***/
/*** Inclusion of PX-AP                           ***/
  u=(Complex *)GC_malloc(n*n*sizeof(Complex));
  d=(Complex *)GC_malloc(n*n*sizeof(Complex));
  down();
  slb_complex_matrix_vmultyply(vr, x, d, n, n, n);
  up();
  slb_complex_matrix_vmultyply(vr, x, u, n, n, n);

  for(i=0; i<n*n; i++) {
     vr[i].r=-vr[i].r;
     vr[i].i=-vr[i].i;
  }
  slb_complex_matrix_vmultyply(A, vr, apu, n, n, n);
  for(i=0; i<n*n; ++i) {
     u[i].r += apu[i].r;
     u[i].i += apu[i].i;
  }
  down();
  slb_complex_matrix_vmultyply(A, vr, apd, n, n, n);
  for(i=0; i<n*n; ++i) {
     d[i].r += apd[i].r;
     d[i].i += apd[i].i;
  }

/*** Calculation of an error bound of X (2)       ***/
/*** Inclusion of inv(P)*(PX-AP)                  ***/
  slb_complex_matrix_interval_vmultyply(c, d, u, apd, apu, n, n); 
  GC_free(c);
  up();
  tt = norm_interval_matrix(apd, apu, n);
  GC_free(apu);
  GC_free(apd);
  tt/=s;
  printf("norm of ||tilde{X}-P^{-1}AP|| is %10.5e\n", tt);
  for(i=0; i<n*n; ++i) {
      u[i].r = x[i].r; 
      u[i].i = x[i].i; 
  }
  for(i=0; i<n; ++i) {
      u[i+i*n].r -=w[i].r;
      u[i+i*n].i -=w[i].i;
  }
  down();
  for(i=0; i<n*n; ++i) {
      d[i].r = x[i].r; 
      d[i].i = x[i].i; 
  }
  for(i=0; i<n; ++i) {
      d[i+i*n].r -=w[i].r;
      d[i+i*n].i -=w[i].i;
  }
  up();
  norm = norm_interval_matrix(d, u, n);
  tt += norm;
  printf("error is bounded by %10.5e\n", tt);
  time3 = clock();
  printf("time = solution : %5.3f, verification : %5.3f [sec]\n", 
             (double)(time2-time1)/CLOCKS_PER_SEC,
             (double)(time3-time2)/CLOCKS_PER_SEC);

  GC_free(x);
  GC_free(d);
  GC_free(u);
  near();
}

double
norm_interval_matrix2(Complex *apd, Complex *apu, double *ew, long int n)
{
  int i, j;
  double tt, norm;

  for(i=0; i<n*n; ++i) {
      apu[i].r = sqrt(apu[i].r * apu[i].r + apu[i].i * apu[i].i);
      tt = sqrt(apd[i].r*apd[i].r+apd[i].i*apd[i].i);
      if(tt>apu[i].r) {
          apu[i].r = tt;
      }
  }
  norm=0.;
  for(i=0;i<n;++i) {
      ew[i]=0.;
      tt=0.;
      for(j=0;j<n;++j) {
          if(tt < apu[i+j*n].r) {
              tt=apu[i+j*n].r;
              ew[i]+=apu[i+j*n].r;
          } 
      } 
      if(tt > norm) {
          norm = tt;
      }
  }
  return norm;
}

void 
slb_gec_matrix_veigenvalue2(Complex *A, Complex *w, Complex *vr, long int n)
{
  char jobvl = 'N', jobvr = 'V';
  long int lda, info, lwork;
  long int ldvl, ldvr;
  Complex *work, *c, *vl, *d, *x, *q, *apu, *apd, *u;
  double *rwork, norm, temp1, tt, s, *ew, *ee, *kappa;
  int i, j;
  long int time1,time2,time3;

/*** Determine Approximate eigen systems        ***/
/*** w is a vector consisting of vegenvalues,   ***/
/*** vr is a matrix of right eigenvectors       ***/ 
  time1 = clock();
  ldvl = 1;
  vl = (Complex *)GC_malloc(ldvl*sizeof(Complex));
  ldvr = n;
  c=(Complex *)GC_malloc(n*n*sizeof(Complex));
  for(i=0; i<n*n; ++i) {
     c[i].r=A[i].r;
     c[i].i=A[i].i;
  }
  lda = n;
  lwork = 64*n;
  work = (Complex *)GC_malloc(lwork*sizeof(Complex));
  rwork = (double *)GC_malloc_atomic(2*n*sizeof(double));
  zgeev_(&jobvl, &jobvr, &n, c, &lda, w, vl, &ldvl, vr, &ldvr, work, &lwork, rwork, &info);

  GC_free(work); 
  GC_free(rwork); 
  GC_free(vl);

  time2 = clock();

/*** c is an approximate inverse of vr          ***/
  slb_complex_matrix_inverse(vr, c, n);

/*** Calculation of ||inv(vr)*vr - I||          ***/
  apu=(Complex *)GC_malloc(n*n*sizeof(Complex));
  apd=(Complex *)GC_malloc(n*n*sizeof(Complex));
  down();
  slb_complex_matrix_vmultyply(c, vr, apd, n, n, n);
  for(i=0; i<n; ++i) {
      apd[i+i*n].r -= 1.;
  }
  up();
  slb_complex_matrix_vmultyply(c, vr, apu, n, n, n);
  for(i=0; i<n; ++i) {
      apu[i+i*n].r -= 1.;
  }
  for(i=0; i<n*n; ++i) {
      apu[i].r = sqrt(apu[i].r * apu[i].r + apu[i].i * apu[i].i);
      tt = sqrt(apd[i].r*apd[i].r+apd[i].i*apd[i].i);
      if(tt>apu[i].r) {
          apu[i].r = tt;
      }
  }
  kappa=(double *)GC_malloc(n*n*sizeof(double));
  s=0.;
  for(i=0;i<n;++i) {
      tt=0;
      for(j=0;j<n;++j) {
          tt += apu[i+j*n].r;
      } 
      kappa[i]=tt;
      if(tt > s) {
          s = tt;
      }
  }
  if(s<1) {
      printf("validation is succeeded!\n");
  }
  printf("norm of inv(P)*P-I is %10.5e\n", s);
  down();
  s=1-s;

/*** Calculation of approximate solution of PX=AP ***/
  near();
  slb_complex_matrix_vmultyply(A, vr, apd, n, n, n);
  x=(Complex *)GC_malloc(n*n*sizeof(Complex));
  slab_app_solve_complex_matrix_equation(vr, apd, x, n, n);

/*** Calculation of an error bound of X (1)       ***/
/*** Inclusion of PX-AP                           ***/
  u=(Complex *)GC_malloc(n*n*sizeof(Complex));
  d=(Complex *)GC_malloc(n*n*sizeof(Complex));
  down();
  slb_complex_matrix_vmultyply(vr, x, d, n, n, n);
  up();
  slb_complex_matrix_vmultyply(vr, x, u, n, n, n);

  for(i=0; i<n*n; i++) {
     vr[i].r=-vr[i].r;
     vr[i].i=-vr[i].i;
  }
  slb_complex_matrix_vmultyply(A, vr, apu, n, n, n);
  for(i=0; i<n*n; ++i) {
     u[i].r += apu[i].r;
     u[i].i += apu[i].i;
  }
  down();
  slb_complex_matrix_vmultyply(A, vr, apd, n, n, n);
  for(i=0; i<n*n; ++i) {
     d[i].r += apd[i].r;
     d[i].i += apd[i].i;
  }

/*** Calculation of an error bound of X (2)       ***/
/*** Inclusion of inv(P)*(PX-AP)                  ***/
  slb_complex_matrix_interval_vmultyply(c, d, u, apd, apu, n, n); 
  GC_free(c);
  up();
  ew=(double *)GC_malloc(n*n*sizeof(double));
  tt = norm_interval_matrix2(apd, apu, ew, n);
  GC_free(apu);
  GC_free(apd);
  tt/=s;
  for(i=0; i<n; ++i) {
      kappa[i]*=tt;
  }
  printf("norm of ||tilde{X}-P^{-1}AP|| is %10.5e\n", tt);
  for(i=0; i<n*n; ++i) {
      u[i].r = x[i].r; 
      u[i].i = x[i].i; 
  }
  for(i=0; i<n; ++i) {
      u[i+i*n].r -=w[i].r;
      u[i+i*n].i -=w[i].i;
  }
  down();
  for(i=0; i<n*n; ++i) {
      d[i].r = x[i].r; 
      d[i].i = x[i].i; 
  }
  for(i=0; i<n; ++i) {
      d[i+i*n].r -=w[i].r;
      d[i+i*n].i -=w[i].i;
  }
  up();
  ee=(double *)GC_malloc(n*n*sizeof(double));
  norm = norm_interval_matrix2(d, u, ee, n);
  for(i=0; i<n; ++i) {
      ee[i] += (ew[i]+kappa[i]);
      printf("error is bounded by %10.5e\n", ee[i]);
  }
  tt += norm;
  printf("error:  %10.5e\n", tt);
  time3 = clock();
  printf("time = solution : %5.3f, verification : %5.3f [sec]\n", 
             (double)(time2-time1)/CLOCKS_PER_SEC,
             (double)(time3-time2)/CLOCKS_PER_SEC);

  GC_free(x);
  GC_free(d);
  GC_free(u);
  GC_free(ew);
  GC_free(ee);
  GC_free(kappa);
  near();
}

void 
slb_gec_matrix_eigenvalue(Complex *A, Complex *w, Complex *vr, long int n)
{
  char jobvl = 'N', jobvr = 'V';
  long int lda, info, lwork;
  long int ldvl, ldvr;
  Complex *work, *c, *vl;
  double *rwork;
  int i;

  ldvl = 1;
  vl = (Complex *)GC_malloc(ldvl*sizeof(Complex));
  ldvr = n;

  c=(Complex *)GC_malloc(n*n*sizeof(Complex));
  for(i=0; i<n*n; ++i) {
     c[i].r=A[i].r;
     c[i].i=A[i].i;
  }

  lda = n;
  lwork = 64*n;
  work = (Complex *)GC_malloc(lwork*sizeof(Complex));
  rwork = (double *)GC_malloc_atomic(2*n*sizeof(double));

  zgeev_(&jobvl, &jobvr, &n, c, &lda, w, vl, &ldvl, vr, &ldvr, work, &lwork, rwork, &info);

  GC_free(work); 
  GC_free(rwork); 
  GC_free(vl);
  GC_free(c);
}

void 
slab_app_solve_matrix_equation(double *A, double *B, double *x,long int n, long int m)
{
    int i, j;
    int upper, lower;
    long int inc=1,info,*piv, nrhs;
    double *C;
    char uplo, trans, diag;

    C   = (double*)GC_malloc_atomic(n*n*sizeof(double));
    for(i=0; i<n*n; ++i) {
       C[i] = A[i];
    }
    for(i=0; i<n*m; ++i) {
       x[i] = B[i];
    }
    upper = 1;
    for(i=1; i<n; ++i) {
        for(j=0; j<i; ++j) {
            if (A[i+j*n] != 0.0) {
                upper = 2;
                break;
            }
        }
        if (upper == 2) break;
    }

    lower = 1;
    for (i=0; i<n; ++i) 
    {
        for(j=i+1; j<n; ++j) 
        {
            if(A[i+j*n] != 0.0) 
            {
                lower = 2;
                break;
            }
        }
        if (lower == 2) break;
    }

    if (upper == 1) 
    {
        uplo = 'U';
        trans = 'N';
        diag = 'N';
        nrhs = m;
        dtrtrs_(&uplo, &trans, &diag, &n, &nrhs, C, &n, x, &n, &info);
    }
    else
    {
        if (lower == 1) 
        {  
            uplo = 'L';
            trans = 'N';
            diag = 'N';
            nrhs = m;
            dtrtrs_(&uplo, &trans, &diag, &n, &nrhs, C, &n, x, &n, &info);
        } 
        else 
        {
            piv = (long int*)GC_malloc_atomic(n*sizeof(long int));
            for(i=0; i<n; i++) {
                piv[i]=0;
            }
            inc = m;
            dgesv_(&n,&inc,C,&n,piv,x,&n,&info);
            GC_free(piv); 
        }
    }
    GC_free(C);
}

void 
slab_app_solve_complex_matrix_equation(Complex *A, Complex *B, Complex *x,long int n, long int m)
{
    int i, j;
    long int nrhs,info,*piv;
    Complex *C;
    int upper, lower;
    char uplo, trans, diag;

    nrhs = m;

    C   = (Complex *)GC_malloc_atomic(n*n*sizeof(Complex));

    for(i=0; i<n*m; ++i) {
       x[i].r = B[i].r;
       x[i].i = B[i].i;
    }

    for(i=0; i<n*n; ++i) {
       C[i].r = A[i].r;
       C[i].i = A[i].i;
    }

    upper = 1;
    for(i=1; i<n; ++i) 
    {
        for(j=0; j<i; ++j) 
        {
            if ((A[i+j*n].r != 0.0) || (A[i+j*n].i != 0,0)) 
            {
                upper = 2;
                break;
            }
        }
        if (upper == 2) break;
    }

    lower = 1;
    for (i=0; i<n; ++i) 
    {
        for(j=i+1; j<n; ++j) 
        {
            if ((A[i+j*n].r != 0.0) || (A[i+j*n].i != 0,0)) 
            {
                lower = 2;
                break;
            }
        }
        if (lower == 2) break;
    }

    if (upper == 1) 
    {
        uplo = 'U';
        trans = 'N';
        diag = 'N';
        nrhs = m;
        ztrtrs_(&uplo, &trans, &diag, &n, &nrhs, C, &n, x, &n, &info);
    }
    else
    {
        if (lower == 1) 
        {  
            uplo = 'L';
            trans = 'N';
            diag = 'N';
            nrhs = m;
            ztrtrs_(&uplo, &trans, &diag, &n, &nrhs, C, &n, x, &n, &info);
        } 
        else 
        { 
            piv = (long int*)GC_malloc_atomic(n*sizeof(long int));
            for(i=0; i<n; i++) {
                piv[i]=0;
            }
            zgesv_(&n,&nrhs,C,&n,piv,x,&n,&info);
            GC_free(piv); 
        } 
    }
    GC_free(C); 
}

void slab_solve_matrix_equation(double *A, double *B, double *x,long int N, long int m)
{
  int i,j;
  long int inc=1,info,*piv;
  long int time1,time2,time3,n;
  double *c, *g;

  n = N;
  piv = (long int*)GC_malloc_atomic(n*sizeof(long int));
  for(i=0; i<n; i++) {
      piv[i]=0;
  }
  c = (double*)GC_malloc_atomic(n*n*sizeof(double)); 

  for(i=0;i<n;i++) {
    for(j=0;j<n;j++) {
          c[i+j*n] = A[i+j*n];
    }
  } 


  for(i=0; i<n*m; i++) {
     x[i]=B[i];
  }

  inc = m;
  time1 = clock();
  dgesv_(&n,&inc,c,&n,piv,x,&n,&info);
  time2 = clock();

  g = (double*)GC_malloc_atomic(n*n*sizeof(double)); 

  luguaB1(c,B,A,g,x,N,m); 
  GC_free(c);
  GC_free(g);
  GC_free(piv); 
  near();
  time3 = clock();

  printf("time = solution : %5.3f, verification : %5.3f [sec]\n", 
             (double)(time2-time1)/CLOCKS_PER_SEC,
             (double)(time3-time2)/CLOCKS_PER_SEC);

}

void slab_solve_matrix_equation1(double *A, double *B, double *B1, double *x,long int N, long int m)
{
  int i,j;
  long int inc=1,info,*piv;
  long int time1,time2,time3,n;
  double *c, *g;

  n = N;
  piv = (long int*)GC_malloc_atomic(n*sizeof(long int));
  for(i=0; i<n; i++) {
      piv[i]=0;
  }
  c = (double*)GC_malloc_atomic(n*n*sizeof(double)); 

  for(i=0;i<n;i++) {
    for(j=0;j<n;j++) {
          c[i+j*n] = A[i+j*n];
    }
  } 


  for(i=0; i<n*m; i++) {
     x[i]=B[i];
  }

  inc = m;
  time1 = clock();
  dgesv_(&n,&inc,c,&n,piv,x,&n,&info);
  time2 = clock();

  g = (double*)GC_malloc_atomic(n*n*sizeof(double)); 

  luguaB2(c,B,B1,A,g,x,N,m); 
  GC_free(c);
  GC_free(g);
  GC_free(piv); 
  near();
  time3 = clock();

  printf("time = solution : %5.3f, verification : %5.3f [sec]\n", 
             (double)(time2-time1)/CLOCKS_PER_SEC,
             (double)(time3-time2)/CLOCKS_PER_SEC);

}

static double ddmB(double *a, double *g, long int N)
{
  char chu='u',chn='n',chl='l';
  int i,j;
  long int n,inc=1;
  double sum,add,*e,*p;
  double *tmp;
  n = N;
  tmp = (double*)GC_malloc_atomic(N*N * sizeof(double));
  for(i=0; i<N*N; i++) {
     tmp[i] = 0.;
  }
  e = (double*)GC_malloc_atomic((N+5)*sizeof(double));
  for(i=0; i<N+5; i++) {
      e[i] = 0.;
  }
  p = (double*)GC_malloc_atomic((N+5)*sizeof(double));
  for(i=0; i<N+5; i++) {
      p[i] = 0.; 
  }

  for(i=0;i<N;i++) e[i] = 1.0;

  for(i=0;i<N;i++)
    for(j=0;j<N;j++)
      tmp[i+j*N] = fabs(a[i+j*N]);

  dtrmv_(&chu,&chn,&chn,&n,tmp,&n,e,&inc);

  dcopy_(&n,e,&inc,p,&inc);
  dtrmv_(&chl,&chn,&chu,&n,tmp,&n,e,&inc);

  for(i=0;i<N;i++)
    for(j=0;j<N;j++)
      tmp[i+j*N] = fabs(g[i+j*N]);

  dtrmv_(&chl,&chn,&chu,&n,tmp,&n,e,&inc);
  dtrmv_(&chu,&chn,&chn,&n,tmp,&n,e,&inc);
  dtrmv_(&chu,&chn,&chn,&n,tmp,&n,p,&inc);
  sum = e[idamax_(&n,e,&inc)-1];
  add = p[idamax_(&n,p,&inc)-1];
  return (2.0*sum + add);

  GC_free(tmp);
  GC_free(e);
  GC_free(p); 
}

static double normB(double *g, long int N)
{
  int i,j;
  long int n;
  double f = 0.0,ff = 0.0,sum =0.;
  
  n = N;
  for(i=0;i<n;i++){
    sum = 1.0;
    for(j=0;j<i;j++) sum += fabs(g[i+j*N]);
    if(sum>f) f = sum;
  }
  for(i=0;i<n;i++){
    sum = fabs(g[i+i*N]);
    for(j=i+1;j<n;j++) sum += fabs(g[i+j*N]);
    if(sum>ff) ff = sum;
  }
  f *= ff;

  return f;
}

static void luguaB(double *a, double *b, double *aa, double *g, double *x, long int N, long int m)
{
  long int n,inc = 1,info;
  int i;
  double p1=1.0,m1=-1.0;
  char chu='u',chl='l',chn='n';
  double u,u1,u2,u3,uu,gamma,d_u,kd;
  double a1,a2,vv,err,nr;
  double *r_u, *r_l, condition_number;
  r_u = (double*)GC_malloc_atomic(N*m*sizeof(double)); 
  for(i=0; i<N; i++) {
      r_u[i]=0.;
  }
  r_l = (double*)GC_malloc_atomic(N*m*sizeof(double)); 
  for(i=0; i<N; i++) {
      r_l[i]=0.;
  }
  n = N;
  dlacpy_(&chn,&n,&n,a,&n,g,&n);
  dtrtri_(&chl,&chu,&n,g,&n,&info);
  dtrtri_(&chu,&chn,&n,g,&n,&info);

  up();
  u1 = 1./2.;
  u1 *= u1;
  u1 *= u1;
  u2 = u1/2.;
  u1 *= u1;
  u3 = u1 *= u1;
  u1 *= u1;
  u = u1*u3*u2;
  down();
  uu = 1.-n*u;
  up();
  gamma = n*u/uu;
  d_u = ddmB(a,g,N);
  d_u *= gamma;
  down();
  kd = 1.-d_u;

  dcopy_(&n,b,&inc,r_l,&inc);
  dgemv_(&chn,&n,&n,&p1,aa,&n,x,&inc,&m1,r_l,&inc);
  a1 = fabs(r_l[idamax_(&n,r_l,&inc)-1]);
  up();
  dcopy_(&n,b,&inc,r_u,&inc);
  dgemv_(&chn,&n,&n,&p1,aa,&n,x,&inc,&m1,r_u,&inc);
  a2 = fabs(r_u[idamax_(&n,r_u,&inc)-1]);
  if(a2>a1) a1 = a2;

  dtrmv_(&chl,&chn,&chu,&n,g,&n,r_u,&inc);
  dtrmv_(&chu,&chn,&chn,&n,g,&n,r_u,&inc);
  down();
  dtrmv_(&chl,&chn,&chu,&n,g,&n,r_l,&inc);
  dtrmv_(&chu,&chn,&chn,&n,g,&n,r_l,&inc);
  up();
  u = fabs(r_u[idamax_(&n,r_u,&inc)-1]);
  vv = fabs(r_l[idamax_(&n,r_u,&inc)-1]); 
  if(vv<u) vv = u;

  err = vv/kd;
  condition_number = normB(g,N);
  nr = condition_number/kd;

/*  printf("residue = %20.18lg\n",a1); 
  printf("||RA-I|| = %20.18lg\n",d_u);
  printf("||R(Ac-b)|| = %20.18lg\n",vv);
*/

  if (kd <= 0) {
     printf("Ill conditioned problem so that verification failed!\n");
     printf("      guessed condition = %17.15f, residue <= %20.15f\n\n", condition_number, a1);
  } else {
     printf("guaranteed result =\n");
     printf("      error <= %17.15f, residue <= %20.15f, |A^{-1}| <= %5.3f\n\n",err, a1,nr);
  }
  GC_free(r_u);
  GC_free(r_l);
}

static void luguaB1(double *a, double *b, double *aa, double *g, double *x, long int N, long int m)
{
  long int n,inc = 1,info;
  int i;
  double p1=1.0,m1=-1.0;
  char chu='u',chl='l',chn='n';
  double u,u1,u2,u3,uu,gamma,d_u,kd;
  double a1,a2,vv,err,nr;
  double *r_u, *r_l, condition_number;
  double *c, *r, *ag, *mag, *c1, *r1;
  c = (double*)GC_malloc_atomic(N*m*sizeof(double));
  r = (double*)GC_malloc_atomic(N*m*sizeof(double));
  c1 = (double*)GC_malloc_atomic(N*m*sizeof(double));
  r1 = (double*)GC_malloc_atomic(N*m*sizeof(double));
  ag = (double*)GC_malloc_atomic(N*N*sizeof(double));
  mag = (double*)GC_malloc_atomic(N*N*sizeof(double));
  r_u = (double*)GC_malloc_atomic(N*m*sizeof(double)); 
  for(i=0; i<N; i++) {
      r_u[i]=0.;
  }
  r_l = (double*)GC_malloc_atomic(N*m*sizeof(double)); 
  for(i=0; i<N; i++) {
      r_l[i]=0.;
  }
  n = N;
  dlacpy_(&chn,&n,&n,a,&n,g,&n);
  dtrtri_(&chl,&chu,&n,g,&n,&info);
  dtrtri_(&chu,&chn,&n,g,&n,&info);

  up();
  u1 = 1./2.;
  u1 *= u1;
  u1 *= u1;
  u2 = u1/2.;
  u1 *= u1;
  u3 = u1 *= u1;
  u1 *= u1;
  u = u1*u3*u2;
  down();
  uu = 1.-n*u;
  up();
  gamma = n*u/uu;
  d_u = ddmB(a,g,N);
  d_u *= gamma;
  down();
  kd = 1.-d_u;


  down();
  for(i=0; i<N*m; ++i) {
     r_l[i] = b[i];
  }
  for(i=0; i<N*N; ++i) {
     ag[i]=fabs(g[i]);
     mag[i]=-fabs(g[i]);
  }
  dgemv_(&chn,&n,&n,&p1,aa,&n,x,&inc,&m1,r_l,&inc);
  a1 = fabs(r_l[idamax_(&n,r_l,&inc)-1]);
  up();
  for(i=0; i<N*m; ++i) {
     r_u[i] = b[i];
  }
  dgemv_(&chn,&n,&n,&p1,aa,&n,x,&inc,&m1,r_u,&inc);
  a2 = fabs(r_u[idamax_(&n,r_u,&inc)-1]);
  if(a2>a1) a1 = a2;

  for(i=0; i<N*m; ++i) {
      c[i]=r_u[i]-r_l[i];
      r[i]=c[i]-r_l[i];
  }
  for(i=0; i<N*m; ++i) {
      c1[i]=r_u[i]-r_l[i];
      r1[i]=c[i]-r_l[i];
  }
  dtrmv_(&chl,&chn,&chu,&n,g,&n,c,&inc);
  dtrmv_(&chl,&chn,&chu,&n,ag,&n,r,&inc);
  for(i=0; i<N*m; ++i) {
    r_u[i]=c[i]+r[i];
  }
  down();
  dtrmv_(&chl,&chn,&chu,&n,g,&n,c1,&inc);
  dtrmv_(&chl,&chn,&chu,&n,mag,&n,r1,&inc);
  for(i=0; i<N*m; ++i) {
    r_l[i]=c1[i]+r1[i];
  }
  up();
  for(i=0; i<N*m; ++i) {
      c[i]=r_u[i]-r_l[i];
      r[i]=c[i]-r_l[i];
  }
  for(i=0; i<N*m; ++i) {
      c1[i]=r_u[i]-r_l[i];
      r1[i]=c[i]-r_l[i];
  }
  dtrmv_(&chu,&chn,&chn,&n,g,&n,c,&inc);
  dtrmv_(&chu,&chn,&chn,&n,ag,&n,r,&inc);
  for(i=0; i<N*m; ++i) {
    r_u[i]=c[i]+r[i];
  }
  down();
  dtrmv_(&chu,&chn,&chn,&n,g,&n,c1,&inc);
  dtrmv_(&chu,&chn,&chn,&n,mag,&n,r1,&inc);
  for(i=0; i<N*m; ++i) {
    r_l[i]=c1[i]+r1[i];
  }
  up();
  u = fabs(r_u[idamax_(&n,r_u,&inc)-1]);
  vv = fabs(r_l[idamax_(&n,r_u,&inc)-1]); 
  if(vv<u) vv = u;

  err = vv/kd;
  condition_number = normB(g,N);
  nr = condition_number/kd;

/*  printf("residue = %20.18lg\n",a1); 
  printf("||RA-I|| = %20.18lg\n",d_u);
  printf("||R(Ac-b)|| = %20.18lg\n",vv);
*/

  if (kd <= 0) {
     printf("Ill conditioned problem so that verification failed!\n");
     printf("      guessed condition = %17.15f, residue <= %20.15f\n\n", condition_number, a1);
  } else {
     printf("guaranteed result =\n");
     printf("      error <= %17.15f, residue <= %20.15f, |A^{-1}| <= %5.3f\n\n",err, a1,nr);
  }
  GC_free(r_u);
  GC_free(r_l);
  GC_free(c);
  GC_free(r);
  GC_free(c1);
  GC_free(r1);
  GC_free(ag);
  GC_free(mag);
}

static void luguaB2(double *a, double *b, double *b1, double *aa, double *g, double *x, long int N, long int m)
{
  long int n,inc = 1,info;
  int i;
  double p1=1.0,m1=-1.0;
  char chu='u',chl='l',chn='n';
  double u,u1,u2,u3,uu,gamma,d_u,kd;
  double a1,a2,vv,err,nr;
  double *r_u, *r_l, condition_number;
  double *c, *r, *ag, *mag, *c1, *r1;
  c = (double*)GC_malloc_atomic(N*m*sizeof(double));
  r = (double*)GC_malloc_atomic(N*m*sizeof(double));
  c1 = (double*)GC_malloc_atomic(N*m*sizeof(double));
  r1 = (double*)GC_malloc_atomic(N*m*sizeof(double));
  ag = (double*)GC_malloc_atomic(N*N*sizeof(double));
  mag = (double*)GC_malloc_atomic(N*N*sizeof(double));
  r_u = (double*)GC_malloc_atomic(N*m*sizeof(double)); 
  for(i=0; i<N; i++) {
      r_u[i]=0.;
  }
  r_l = (double*)GC_malloc_atomic(N*m*sizeof(double)); 
  for(i=0; i<N; i++) {
      r_l[i]=0.;
  }
  n = N;
  dlacpy_(&chn,&n,&n,a,&n,g,&n);
  dtrtri_(&chl,&chu,&n,g,&n,&info);
  dtrtri_(&chu,&chn,&n,g,&n,&info);

  up();
  u1 = 1./2.;
  u1 *= u1;
  u1 *= u1;
  u2 = u1/2.;
  u1 *= u1;
  u3 = u1 *= u1;
  u1 *= u1;
  u = u1*u3*u2;
  down();
  uu = 1.-n*u;
  up();
  gamma = n*u/uu;
  d_u = ddmB(a,g,N);
  d_u *= gamma;
  down();
  kd = 1.-d_u;


  down();
  for(i=0; i<N*m; ++i) {
     r_l[i] = b[i];
  }
  for(i=0; i<N*N; ++i) {
     ag[i]=fabs(g[i]);
     mag[i]=-fabs(g[i]);
  }
  dgemv_(&chn,&n,&n,&p1,aa,&n,x,&inc,&m1,r_l,&inc);
  a1 = fabs(r_l[idamax_(&n,r_l,&inc)-1]);
  up();
  for(i=0; i<N*m; ++i) {
     r_u[i] = b1[i];
  }
  dgemv_(&chn,&n,&n,&p1,aa,&n,x,&inc,&m1,r_u,&inc);
  a2 = fabs(r_u[idamax_(&n,r_u,&inc)-1]);
  if(a2>a1) a1 = a2;

  for(i=0; i<N*m; ++i) {
      c[i]=r_u[i]-r_l[i];
      r[i]=c[i]-r_l[i];
  }
  for(i=0; i<N*m; ++i) {
      c1[i]=r_u[i]-r_l[i];
      r1[i]=c[i]-r_l[i];
  }
  dtrmv_(&chl,&chn,&chu,&n,g,&n,c,&inc);
  dtrmv_(&chl,&chn,&chu,&n,ag,&n,r,&inc);
  for(i=0; i<N*m; ++i) {
    r_u[i]=c[i]+r[i];
  }
  down();
  dtrmv_(&chl,&chn,&chu,&n,g,&n,c1,&inc);
  dtrmv_(&chl,&chn,&chu,&n,mag,&n,r1,&inc);
  for(i=0; i<N*m; ++i) {
    r_l[i]=c1[i]+r1[i];
  }
  up();
  for(i=0; i<N*m; ++i) {
      c[i]=r_u[i]-r_l[i];
      r[i]=c[i]-r_l[i];
  }
  for(i=0; i<N*m; ++i) {
      c1[i]=r_u[i]-r_l[i];
      r1[i]=c[i]-r_l[i];
  }
  dtrmv_(&chu,&chn,&chn,&n,g,&n,c,&inc);
  dtrmv_(&chu,&chn,&chn,&n,ag,&n,r,&inc);
  for(i=0; i<N*m; ++i) {
    r_u[i]=c[i]+r[i];
  }
  down();
  dtrmv_(&chu,&chn,&chn,&n,g,&n,c1,&inc);
  dtrmv_(&chu,&chn,&chn,&n,mag,&n,r1,&inc);
  for(i=0; i<N*m; ++i) {
    r_l[i]=c1[i]+r1[i];
  }
  up();
  u = fabs(r_u[idamax_(&n,r_u,&inc)-1]);
  vv = fabs(r_l[idamax_(&n,r_u,&inc)-1]); 
  if(vv<u) vv = u;

  err = vv/kd;
  condition_number = normB(g,N);
  nr = condition_number/kd;

/*  printf("residue = %20.18lg\n",a1); 
  printf("||RA-I|| = %20.18lg\n",d_u);
  printf("||R(Ac-b)|| = %20.18lg\n",vv);
*/

  if (kd <= 0) {
     printf("Ill conditioned problem so that verification failed!\n");
     printf("      guessed condition = %17.15f, residue <= %20.15f\n\n", condition_number, a1);
  } else {
     printf("guaranteed result =\n");
     printf("      error <= %17.15f, residue <= %20.15f, |A^{-1}| <= %5.3f\n\n",err, a1,nr);
  }
  GC_free(r_u);
  GC_free(r_l);
  GC_free(c);
  GC_free(r);
  GC_free(c1);
  GC_free(r1);
  GC_free(ag);
  GC_free(mag);
}
